<?php

require __DIR__.'/bootstrap.php';

set_time_limit(0);

try {
    BuscaParamFis();
} catch (\Exception $e) {
    return $e->getMessage();
}

function BuscaParamFis(){
    try{
        global $instanceManager;
        $rulesClass = $instanceManager->getService('\Controller\ErpController');

        
        $dadosAcesso = $rulesClass->getDadosAcesso();
    
        if(empty($dadosAcesso)) throw new \Exception("Dados de acesso não foram parametrizados.");
    
  
      
        
        $id_cenario = '0';
        $paginacao = 50;
        $last_id_cenario = '0';
        $last_cod_prod = '0';
        $cod_prod = '0';
        $sair = false;
        
        do {
            $buscaParamFis = buscaParamFiscal($dadosAcesso, $id_cenario, $cod_prod, $paginacao, $dadosAcesso["PONTEIRO_ATUALIZACAO"]);      

            if ($buscaParamFis){
                $status = $buscaParamFis->status;
                if($status->cod_status == 0) {
                    $cenarios   = $buscaParamFis->cenario;
                    $ponteiro_atualizacao = $buscaParamFis->ponteiro_atualizacao;
                    if(is_array($cenarios)) {
                        array_map('insereDadosCenario', $cenarios);
                        $ultimoCenario = getDadosUltimoCenario($cenarios, $paginacao);
                        if($ultimoCenario) {
                            $last_id_cenario = $id_cenario;
                            $last_cod_prod   = $cod_prod;
                            $id_cenario = $ultimoCenario["id_cenario"];
                            $cod_prod = $ultimoCenario["cod_prod"];
                        }
                        else {
                            $sair = true;
                        }
                    }
                    else if($cenarios) {
                        insereDadosCenario($cenarios);
                        $ultimoProduto = getUltimoProduto($cenarios, $paginacao, true);
                        if($ultimoProduto) {
                            $last_id_cenario = $id_cenario;
                            $last_cod_prod   = $cod_prod;
                            $id_cenario = $cenarios->id_cenario;
                            $cod_prod = $ultimoProduto->cod_prod;
                        }
                        else $sair = true;
                    }
                    if(!$sair && ($last_id_cenario == $id_cenario && $last_cod_prod == $cod_prod)) $sair = true;
                }
                else {
                    $sair = true;
                    die($status->msg_status);
                }
                
            }
            else {
                echo $buscaParamFis;
                break;
            }

        } while(!$sair);
        
        $rulesClass->atualizaSysDadosAcesso($dadosAcesso["NRSEQDADOAC"], $last_id_cenario, $last_cod_prod, $ponteiro_atualizacao);
        

    }catch(SoapFault $e){
        $geraLog = $rulesClass->insere_log_importa_regrafis($idcenario, $cod_prod, $e->getMessage());
        echo $e->getMessage();
    }
    catch(\Exception $e) {
        echo $e->getMessage();
    }
}

function getDadosUltimoCenario($cenarios, $paginacao) {
    $dadosUltimoCenario = array();
    if(count($cenarios) < $paginacao) {
        $totalRegistros = 0;
                            
        foreach($cenarios as $cenario) {
            if(is_array($cenario->retorno)) {
                $totalRegistros += count($cenario->retorno);
            }
            else {
                $totalRegistros += 1;
            }
        }

        if($totalRegistros < $paginacao) {
            return false;
        }
    }
    $ultimoCenario  = getUltimoCenario($cenarios);
    if($ultimoCenario) {
        $ultimoProduto    = getUltimoProduto($ultimoCenario, $paginacao, false);
        $dadosUltimoCenario = array(
            "id_cenario" => $ultimoCenario->id_cenario,
            "cod_prod"   => $ultimoProduto->cod_prod
              
        );
    }
    else return false;
    
    return $dadosUltimoCenario;
}

function getUltimoCenario($cenarios) {
    $ultimaPosicao = count($cenarios) - 1;
    $ultimoCenario = $cenarios[$ultimaPosicao];
    return $ultimoCenario;
}

function getUltimoProduto($cenario, $paginacao, $checkPaginacao) {
    $produtos = $cenario->retorno;
    if(is_array($produtos)) {
        $ultimaPosicao = count($produtos) - 1;
        if($checkPaginacao && ($paginacao < $ultimaPosicao + 1)) return false;
        $ultimoProduto = $produtos[$ultimaPosicao];
    }
    else {
        return $produtos;
    }

    
    return $ultimoProduto;
}

function insereDadosCenario($cenario) {
    global $instanceManager;
    $rulesClass = $instanceManager->getService('\Controller\ErpController');
    $showLog = false;

    $log = array(
        "prod_inserido"     => 0,
        "prod_atualizado"   => 0,
        "icms_inserido"     => 0,
        "icms_atualizado"   => 0,
        "icmsst_inserido"     => 0,
        "icmsst_atualizado"   => 0,
        "ipi_inserido"      => 0,
        "ipi_atualizado"    => 0,
        "pis_inserido"      => 0,
        "pis_atualizado"    => 0,
        "cofins_inserido"   => 0,
        "cofins_atualizado" => 0
    );

    $existeCenario = $rulesClass->busca_sys_cenario($cenario->id_cenario);
    
    $produtos = $cenario->retorno;
    
    if(!is_array($produtos)) {
        $produtos = array($produtos);
    }

    $produtos = array_filter($produtos, function ($produto) use ($rulesClass) {
        return $rulesClass->existeProduto($produto->cod_prod);
    });

    
    if(!empty($produtos)) {
        if(empty($existeCenario)) {
            $idcenario = insere_cenario($cenario, $rulesClass);
            if($showLog) echo "Cenario $idcenario inserido.";
        }
        else {
            $idcenario = $cenario->id_cenario;
            if($showLog) echo "Cenario $idcenario sera atualizado.";
        }

        foreach($produtos as $produto) {
            try {
                insereDadosProdutosCenario($produto, $idcenario, $log);
            }
            catch(\Exception $e) {
                $cod_prod = $produto->cod_prod;
                echo "\nErro produto $cod_prod: " . $e->getMessage();
            }
        }
        
        if($showLog) {
            var_dump($log);
        }

    }
    else {
        echo "\nNenhum Produto encontrado para o cenário\n";
    }
                            
}

function insereDadosProdutosCenario($produto, $idcenario, &$log) {
    global $instanceManager;
    $rulesClass = $instanceManager->getService('\Controller\ErpController');

    if($produto) {
        $cod_prod = $produto->cod_prod;
        $ori_prod = (property_exists($produto, 'origem_produto')) ? $produto->origem_produto : '';
    
        $produtoCadastrado = $rulesClass->busca_produto($idcenario, $cod_prod, $ori_prod);
    
        if(empty($produtoCadastrado)) {
            $resultado = insere_produto($produto, $idcenario, $rulesClass);
            $log["prod_inserido"]++;
        }
        else {
            $resultado = update_produto($produto, $idcenario, $rulesClass);
            $log["prod_atualizado"]++;
        }
        
        $icms      = $produto->icms;

        if($icms) {
            $vig_de = (property_exists($icms, 'vigencia_de')) ? $icms->vigencia_de : '';
            $vig_ate = (property_exists($icms, 'vigencia_ate')) ? $icms->vigencia_ate : '';
            $vig_de_UF_destino = ''; 
            $vig_ate_UF_destino = '';
            $uf_destino = false;
            
            if(property_exists($icms, 'icms_uf_dest')){
                $icmsDest = $icms->icms_uf_dest;
                $vig_de_UF_destino = (property_exists($icms, 'vigencia_de'))   ? $icms->vigencia_de : '';
                $vig_ate_UF_destino =  (property_exists($icms, 'vigencia_ate'))  ? $icms->vigencia_ate : '';
                $uf_destino = true;
            }
            
            $existeIcms = $rulesClass->busca_icms($idcenario, $cod_prod, $icms->cst, $vig_de, $vig_ate, $vig_de_UF_destino, $vig_ate_UF_destino, $uf_destino, $ori_prod);
            
            if($existeIcms === false) {
                /* valores referentes ao icms */
                $resultado = insere_icms($icms, $idcenario, $cod_prod, $rulesClass, $ori_prod);
                $log["icms_inserido"]++;
            }
            else {
                $resultado = update_icms($icms, $idcenario, $cod_prod, $rulesClass, $ori_prod);
                $log["icms_atualizado"]++;
            }
            
            $icms_st = (property_exists($icms, 'icms_st'))     ? $icms->icms_st : '';
            if($icms_st) {
                $vig_de = (property_exists($icms_st, 'vigencia_de')) ? $icms_st->vigencia_de : '';
                $vig_ate = (property_exists($icms_st, 'vigencia_ate')) ? $icms_st->vigencia_ate : '';
                $existeIcmsst = $rulesClass->busca_icmsst($idcenario, $cod_prod, $vig_de, $vig_ate, $ori_prod);

                if($existeIcmsst === false) {
                /* valores referentes ao icms */
                    $resultado = insere_icmsst($icms_st, $idcenario, $cod_prod, $rulesClass, $ori_prod);
                    $log["icmsst_inserido"]++;
                }
                else {
                    $resultado = update_icmsst($icms_st, $idcenario, $cod_prod, $rulesClass, $ori_prod);
                    $log["icmsst_atualizado"]++;
                }
            }
        }
    
        /* valores referentes ao pis */
        $pis       = $produto->pis;    
        if($pis) {
            $vig_de = (property_exists($pis, 'vigencia_de')) ? $pis->vigencia_de : '';
            $vig_ate = (property_exists($pis, 'vigencia_ate')) ? $pis->vigencia_ate : '';
            $existePis = $rulesClass->busca_pis($idcenario, $cod_prod, $pis->cst, $vig_de, $vig_ate, $ori_prod);

            if($existePis === false) {
                $resultado = insere_pis($pis, $idcenario, $cod_prod, $rulesClass, $ori_prod);
                $log["pis_inserido"]++;
            }
            else {
                $resultado = update_pis($pis, $idcenario, $cod_prod, $rulesClass, $ori_prod);
                $log["pis_atualizado"]++;
            }
        }
    
        /* valores referentes ao cofins */
        $cofins    = $produto->cofins;       
        if($cofins) {
            $vig_de = (property_exists($cofins, 'vigencia_de')) ? $cofins->vigencia_de : '';
            $vig_ate = (property_exists($cofins, 'vigencia_ate')) ? $cofins->vigencia_ate : '';
            $existeCofins = $rulesClass->busca_cofins($idcenario, $cod_prod, $cofins->cst, $vig_de, $vig_ate, $ori_prod);
            if($existeCofins === false) {
                $resultado = insere_cofins($cofins, $idcenario, $cod_prod, $rulesClass, $ori_prod);
                $log["cofins_inserido"]++;
            }
            else {
                $log["cofins_atualizado"]++;
                $resultado = update_cofins($cofins, $idcenario, $cod_prod, $rulesClass, $ori_prod);
            }
        }
        
        /* valores referentes ao ipi */
        $ipi = $produto->ipi;        
        if($ipi) {
            $vig_de = (property_exists($ipi, 'vigencia_de')) ? $ipi->vigencia_de : '';
            $vig_ate = (property_exists($ipi, 'vigencia_ate')) ? $ipi->vigencia_ate : '';
            $existeIpi = $rulesClass->busca_ipi($idcenario, $cod_prod, $ipi->cst, $vig_de, $vig_ate, $ori_prod);
            if($existeIpi === false) {
                $resultado = insere_ipi($ipi, $idcenario, $cod_prod, $rulesClass, $ori_prod);
                $log["ipi_inserido"]++;
            }
            else {
                $log["ipi_atualizado"]++;
                $resultado = update_ipi($ipi, $idcenario, $cod_prod, $rulesClass, $ori_prod);
            }
        }
        
    }
                        
}

function buscaParamFiscal($dadosAcesso, $id_cenario, $cod_prod, $paginacao, $ponteiro_atualizacao) {
    
    $wsdl = $dadosAcesso["URL_ERP"];
    $usuario = $dadosAcesso["USUARIO"];
    $senha = $dadosAcesso["SENHA"];

    $client = new SoapClient($wsdl, array('trace' => 1));
    
    $xml = '<systax_erp>
                <usuario>'.$usuario.'</usuario>
                <senha>'.$senha.'</senha>
                <id_cenario>'.$id_cenario.'</id_cenario>
                <codigo_produto>'.$cod_prod.'</codigo_produto>
                <paginacao>'.$paginacao.'</paginacao>';
    if($ponteiro_atualizacao) {
        $xml.= '
                <ponteiro_atualizacao>'.$ponteiro_atualizacao.'</ponteiro_atualizacao>';
    }
    $xml.=  '
            </systax_erp>';

    $xmlSimple = simplexml_load_string($xml);

    $xmlSimple = xml2array($xmlSimple);
    
    var_dump($id_cenario, $cod_prod);
    
    return $client->__soapCall('systax_erp', $xmlSimple); 
}

function xml2array($xmlObject, $out = array()){
    foreach ((array) $xmlObject as $index => $node)
        $out[$index] = (is_object($node)) ? xml2array($node) : $node;
    
    return $out;
}

function insere_cenario($ins_cenario, $rulesClass){
    try{
        $cenario = $ins_cenario;
        
        $idcenario = $cenario->id_cenario;
        $apelido   = $cenario->apelido;
        $dias_fut  = (property_exists($cenario, 'dias_futuros'))          ? $cenario->dias_futuros : '';
        $uf_origem = $cenario->uf_origem;
        $uf_dest   = $cenario->uf_destino;
        $origem    = (property_exists($cenario, 'origem'))                ? $cenario->origem : '';
        $destina   = (property_exists($cenario, 'destinacao'))            ? $cenario->destinacao : '';
        $cod_natop = (property_exists($cenario, 'cod_natureza_operacao')) ? $cenario->cod_natureza_operacao : ''; 
        $ent_sai   = (property_exists($cenario, 'ent_sai'))               ? $cenario->ent_sai : '';
        $mun_orig  = (property_exists($cenario, 'municipio_origem'))      ? $cenario->municipio_origem : '';
        $mun_dest  = (property_exists($cenario, 'municipio_destino'))     ? $cenario->municipio_destino : '';
        $cnae_dest = (property_exists($cenario, 'cnae_destinatario'))     ? $cenario->cnae_destinatario : '';
        
        $rulesClass->insere_sys_cenario($idcenario, $dias_fut, $uf_origem, $uf_dest, $origem, $destina, $cod_natop, $mun_orig, $mun_dest, $cnae_dest, $ent_sai, $apelido);
        
        $response = $idcenario;

        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();
        $response = $e->getMessage();
        return $response;
    }
}

function insere_produto($ins_produto, $idcenario, $rulesClass){
    try{
        $produtos = $ins_produto;
        $cod_prod = $produtos->cod_prod;
        $ean      = (property_exists($produtos, 'ean'))       ? $produtos->ean : '';
        $ncm      = (property_exists($produtos, 'ncm'))       ? $produtos->ncm : ''; 
        $ori_prod = (property_exists($produtos, 'origem_produto')) ? $produtos->origem_produto : '';
        $cfop     = $produtos->cfop;
        $cest     = (property_exists($produtos, 'cest'))      ? $produtos->cest : '';
        $ex_tipi  = (property_exists($produtos, 'ex_tipi'))   ? $produtos->ex_tipi : '';
        $descr    = (property_exists($produtos, 'descricao')) ? $produtos->descricao : '';
        
        $rulesClass->insere_sys_material($idcenario, $cod_prod, $descr, $ean, $ncm, $ex_tipi, $ori_prod, $cfop, $cest);
        
        $response = 'ok';
        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();
        $response = $e->getMessage();
        return $response;
    }
}

function update_produto($produto, $idcenario, $rulesClass){
    try{
        $cod_prod = $produto->cod_prod;
        $ean      = (property_exists($produto, 'ean'))       ? $produto->ean : '';
        $ncm      = (property_exists($produto, 'ncm'))       ? $produto->ncm : ''; 
        $ori_prod = (property_exists($produto, 'origem_produto')) ? $produto->origem_produto : '';
        $cfop     = $produto->cfop;
        $cest     = (property_exists($produto, 'cest'))      ? $produto->cest : '';
        $ex_tipi  = (property_exists($produto, 'ex_tipi'))   ? $produto->ex_tipi : '';
        $descr    = (property_exists($produto, 'descricao')) ? $produto->descricao : '';
        
        $rulesClass->update_sys_material($idcenario, $cod_prod, $descr, $ean, $ncm, $ex_tipi, $ori_prod, $cfop, $cest);
        
        $response = 'ok';
        return $response;
        
    }catch(SoapFault $e){
        echo $e->getMessage();
        $response = $e->getMessage();
        return $response;
    }
}

function insere_icms($ins_icms, $idcenario, $cod_prod, $rulesClass, $ori_prod){
    try{
        $icms      = $ins_icms;
        $cst       = $icms->cst;
        $bc_compos = (property_exists($icms, 'bc_composicao')) ? $icms->bc_composicao : '';
        $aliquota  = (property_exists($icms, 'aliquota'))      ? $icms->aliquota : 0;
        $p_red_bc  = (property_exists($icms, 'p_red_bc'))      ? $icms->p_red_bc : '';
        $vigen_de  = (property_exists($icms, 'vigencia_de'))   ? $icms->vigencia_de : '';
        $vigen_ate = (property_exists($icms, 'vigencia_ate'))  ? $icms->vigencia_ate : '';
        $disposit  = (property_exists($icms, 'dispositivo'))   ? $icms->dispositivo : '';
        $observac  = (property_exists($icms, 'observacao'))    ? $icms->observacao : '';
        $infoAdic  = (property_exists($icms, 'inf_adicionais'))    ? $icms->inf_adicionais : '';
         // ICMS UF DESTINO
        $paramsUfDest = null;
        if(property_exists($icms, 'icms_uf_dest')){
            $icmsDest = $icms->icms_uf_dest;
            
            $paramsUfDest = array(
                ":P_CST_UF_DEST" =>  (property_exists($icmsDest, 'cst'))      ? $icmsDest->cst : null ,
                ":P_ALIQ_UF_DEST"  => (property_exists($icmsDest, 'aliquota')) ? $icms->aliquota:  0 ,
                ":P_BC_COMP_UF_DEST" => (property_exists($icmsDest, 'bc_composicao')) ? $icmsDest->bc_composicao : null,
                ":P_BC_COMP_FCP_UF_DEST" => (property_exists($icmsDest, 'bc_composicao_fcp')) ? $icmsDest->bc_composicao_fcp : null,
                ":P_RED_BC_ST_UF_DEST"  => (property_exists($icmsDest, 'p_red_bc'))      ? $icmsDest->p_red_bc : null,
                ":P_ALIQ_INT_UF_DEST"  => (property_exists($icmsDest, 'aliq_interna_dest'))      ? $icmsDest->aliq_interna_dest : 0,
                ":P_FCP_UF_DEST"  => (property_exists($icmsDest, 'fcp'))      ? $icmsDest->fcp : null,
                ":P_PERC_PART_UF_DEST"  => (property_exists($icmsDest, 'perc_partilha_dest')) ? $icmsDest->perc_partilha_dest : null,
                ":P_VR_PAUTA_UF_DEST"  => (property_exists($icmsDest, 'valor_pauta'))      ? $icmsDest->valor_pauta : null,
                ":P_UN_PAUTA_UF_DEST"  => (property_exists($icmsDest, 'unidade_pauta'))      ? $icmsDest->unidade_pauta : null,
                ":P_GENERICO_UF_DEST" => (property_exists($icmsDest, 'generico'))      ? $icmsDest->generico : null,
                ":P_DISP_LEGAL_UF_DEST" => (property_exists($icmsDest, 'dispositivo_legal'))   ? $icmsDest->dispositivo_legal : null,
                ":P_VIG_DE_UF_DEST"  => (property_exists($icms, 'vigencia_de'))   ? $icms->vigencia_de : '',
                ":P_VIG_ATE_UF_DEST" => (property_exists($icms, 'vigencia_ate'))  ? $icms->vigencia_ate : '',
                ":P_OBSERV_UF_DEST"  => (property_exists($icmsDest, 'observacoes'))    ? $icmsDest->observacoes : null
            );
        }
        $rulesClass->insere_imp_systax('SYS_ICMS', $idcenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bc, $vigen_de, $vigen_ate, $disposit, $observac,  $ori_prod, $infoAdic, '', $paramsUfDest);
        $response = 'ok';
        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();
        $response = $e->getMessage();
        return $response;
    }
}

function update_icms($ins_icms, $idcenario, $cod_prod, $rulesClass, $ori_prod){
    try{
        $icms      = $ins_icms;
        $cst       = $icms->cst;
        $bc_compos = (property_exists($icms, 'bc_composicao')) ? $icms->bc_composicao : '';
        $aliquota  = (property_exists($icms, 'aliquota'))      ? $icms->aliquota : 0;
        $p_red_bc  = (property_exists($icms, 'p_red_bc'))      ? $icms->p_red_bc : '';
        $vigen_de  = (property_exists($icms, 'vigencia_de'))   ? $icms->vigencia_de : '';
        $vigen_ate = (property_exists($icms, 'vigencia_ate'))  ? $icms->vigencia_ate : '';
        $disposit  = (property_exists($icms, 'dispositivo'))   ? $icms->dispositivo : '';
        $observac  = (property_exists($icms, 'observacao'))    ? $icms->observacao : '';
        $infoAdic  = (property_exists($icms, 'inf_adicionais'))    ? $icms->inf_adicionais : '';
        
        // ICMS UF DESTINO
        $paramsUfDest = null;
        if(property_exists($icms, 'icms_uf_dest')){
            $icmsDest = $icms->icms_uf_dest;

            $paramsUfDest = array(
                ":P_CST_UF_DEST" =>  (property_exists($icmsDest, 'cst'))      ? $icmsDest->cst : null ,
                ":P_ALIQ_UF_DEST"  => (property_exists($icmsDest, 'aliquota')) ? $icms->aliquota:  0 ,
                ":P_BC_COMP_UF_DEST" => (property_exists($icmsDest, 'bc_composicao')) ? $icmsDest->bc_composicao : null,
                ":P_BC_COMP_FCP_UF_DEST" => (property_exists($icmsDest, 'bc_composicao_fcp')) ? $icmsDest->bc_composicao_fcp : null,
                ":P_RED_BC_ST_UF_DEST"  => (property_exists($icmsDest, 'p_red_bc'))      ? $icmsDest->p_red_bc : null,
                ":P_ALIQ_INT_UF_DEST"  => (property_exists($icmsDest, 'aliq_interna_dest'))      ? $icmsDest->aliq_interna_dest : 0,
                ":P_FCP_UF_DEST"  => (property_exists($icmsDest, 'fcp'))      ? $icmsDest->fcp : null,
                ":P_PERC_PART_UF_DEST"  => (property_exists($icmsDest, 'perc_partilha_dest')) ? $icmsDest->perc_partilha_dest : null,
                ":P_VR_PAUTA_UF_DEST"  => (property_exists($icmsDest, 'valor_pauta'))      ? $icmsDest->valor_pauta : null,
                ":P_UN_PAUTA_UF_DEST"  => (property_exists($icmsDest, 'unidade_pauta'))      ? $icmsDest->unidade_pauta : null,
                ":P_GENERICO_UF_DEST" => (property_exists($icmsDest, 'generico'))      ? $icmsDest->generico : null,
                ":P_DISP_LEGAL_UF_DEST" => (property_exists($icmsDest, 'dispositivo_legal'))   ? $icmsDest->dispositivo_legal : null,
                ":P_VIG_DE_UF_DEST"  => (property_exists($icms, 'vigencia_de'))   ? $icms->vigencia_de : '',
                ":P_VIG_ATE_UF_DEST" => (property_exists($icms, 'vigencia_ate'))  ? $icms->vigencia_ate : '',
                ":P_OBSERV_UF_DEST"  => (property_exists($icmsDest, 'observacoes'))    ? $icmsDest->observacoes : null
            );
        } 

        $rulesClass->update_icms('SYS_ICMS', $idcenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bc, $vigen_de, $vigen_ate, $disposit, $observac,$infoAdic, $paramsUfDest, $ori_prod);

        
        $response = 'ok';
        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();
        $response = $e->getMessage();
        return $response;
    }
}

function insere_pis($ins_pis, $idcenario, $cod_prod, $rulesClass, $ori_prod){
    try{
        $pis       = $ins_pis;
        $cst       = $pis->cst;
        $bc_compos = (property_exists($pis, 'bc_composicao')) ? $pis->bc_composicao : '';
        $aliquota  = (property_exists($pis, 'aliquota'))      ? $pis->aliquota : 0;
        $p_red_bc  = (property_exists($pis, 'p_red_bc'))      ? $pis->p_red_bc : '';
        $vigen_de  = (property_exists($pis, 'vigencia_de'))   ? $pis->vigencia_de : '';
        $vigen_ate = (property_exists($pis, 'vigencia_ate'))  ? $pis->vigencia_ate : '';
        $disposit  = (property_exists($pis, 'dispositivo'))   ? $pis->dispositivo : '';
        $observac  = (property_exists($pis, 'observacao'))    ? $pis->observacao : '';
        $infoAdic  = (property_exists($pis, 'inf_adicionais'))    ? $pis->inf_adicionais : '';
        
        $rulesClass->insere_imp_systax('SYS_PIS', $idcenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bc, $vigen_de, $vigen_ate, $disposit, $observac, $ori_prod, $infoAdic);
        
        $response = 'ok';
        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();
        $response = $e->getMessage();
        return $response;
    }
}

function update_pis($ins_pis, $idcenario, $cod_prod, $rulesClass, $ori_prod){
    try{
        $pis       = $ins_pis;
        $cst       = $pis->cst;
        $bc_compos = (property_exists($pis, 'bc_composicao')) ? $pis->bc_composicao : '';
        $aliquota  = (property_exists($pis, 'aliquota'))      ? $pis->aliquota : 0;
        $p_red_bc  = (property_exists($pis, 'p_red_bc'))      ? $pis->p_red_bc : '';
        $vigen_de  = (property_exists($pis, 'vigencia_de'))   ? $pis->vigencia_de : '';
        $vigen_ate = (property_exists($pis, 'vigencia_ate'))  ? $pis->vigencia_ate : '';
        $disposit  = (property_exists($pis, 'dispositivo'))   ? $pis->dispositivo : '';
        $observac  = (property_exists($pis, 'observacao'))    ? $pis->observacao : '';
        $infoAdic  = (property_exists($pis, 'inf_adicionais'))    ? $pis->inf_adicionais : '';
        
        $rulesClass->update_pis('SYS_PIS', $idcenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bc, $vigen_de, $vigen_ate, $disposit, $observac, $infoAdic, $ori_prod);
        
        $response = 'ok';
        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();     
        $response = $e->getMessage();
        return $response;
    }
}

function insere_cofins($ins_cofins, $idcenario, $cod_prod, $rulesClass, $ori_prod){
    try{
        $cofins = $ins_cofins;
        $cst       = $cofins->cst;
        $bc_compos = (property_exists($cofins, 'bc_composicao')) ? $cofins->bc_composicao : '';
        $aliquota  = (property_exists($cofins, 'aliquota'))      ? $cofins->aliquota : 0;
        $p_red_bc  = (property_exists($cofins, 'p_red_bc'))      ? $cofins->p_red_bc : '';
        $vigen_de  = (property_exists($cofins, 'vigencia_de'))   ? $cofins->vigencia_de : '';
        $vigen_ate = (property_exists($cofins, 'vigencia_ate'))  ? $cofins->vigencia_ate : '';
        $disposit  = (property_exists($cofins, 'dispositivo'))   ? $cofins->dispositivo : '';
        $observac  = (property_exists($cofins, 'observacao'))    ? $cofins->observacao : '';
        $infoAdic  = (property_exists($cofins, 'inf_adicionais'))    ? $cofins->inf_adicionais : '';
        
        $rulesClass->insere_imp_systax('SYS_COFINS', $idcenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bc, $vigen_de, $vigen_ate, $disposit, $observac, $ori_prod, $infoAdic);

        $response = 'ok';
        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();     
        $response = $e->getMessage();
        return $response;
    }
}

function update_cofins($ins_cofins, $idcenario, $cod_prod, $rulesClass, $ori_prod){
    try{
        $cofins = $ins_cofins;
        $cst       = $cofins->cst;
        $bc_compos = (property_exists($cofins, 'bc_composicao')) ? $cofins->bc_composicao : '';
        $aliquota  = (property_exists($cofins, 'aliquota'))      ? $cofins->aliquota : 0;
        $p_red_bc  = (property_exists($cofins, 'p_red_bc'))      ? $cofins->p_red_bc : '';
        $vigen_de  = (property_exists($cofins, 'vigencia_de'))   ? $cofins->vigencia_de : '';
        $vigen_ate = (property_exists($cofins, 'vigencia_ate'))  ? $cofins->vigencia_ate : '';
        $disposit  = (property_exists($cofins, 'dispositivo'))   ? $cofins->dispositivo : '';
        $observac  = (property_exists($cofins, 'observacao'))    ? $cofins->observacao : '';
        $infoAdic  = (property_exists($cofins, 'inf_adicionais'))    ? $cofins->inf_adicionais : '';
        
        $rulesClass->update_cofins('SYS_COFINS', $idcenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bc, $vigen_de, $vigen_ate, $disposit, $observac,$infoAdic, $ori_prod);

        $response = 'ok';
        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();     
        $response = $e->getMessage();
        return $response;
    }
}

function insere_ipi($ins_ipi, $idcenario, $cod_prod, $rulesClass, $ori_prod){
    try{
        $ipi = $ins_ipi;
        $cst       = $ipi->cst;
        $bc_compos = (property_exists($ipi, 'bc_composicao')) ? $ipi->bc_composicao : '';
        $aliquota  = (property_exists($ipi, 'aliquota'))      ? $ipi->aliquota : 0;
        $p_red_bc  = (property_exists($ipi, 'p_red_bc'))      ? $ipi->p_red_bc : '';
        $vigen_de  = (property_exists($ipi, 'vigencia_de'))   ? $ipi->vigencia_de : '';
        $vigen_ate = (property_exists($ipi, 'vigencia_ate'))  ? $ipi->vigencia_ate : '';
        $disposit  = (property_exists($ipi, 'dispositivo'))   ? $ipi->dispositivo : '';
        $observac  = (property_exists($ipi, 'observacao'))    ? $ipi->observacao : '';
        $cenq      = (property_exists($ipi, 'cenq'))          ? $ipi->cenq : '';
        $infoAdic  = (property_exists($ipi, 'inf_adicionais'))    ? $ipi->inf_adicionais : '';
        
        $rulesClass->insere_imp_systax('SYS_IPI', $idcenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bc, $vigen_de, $vigen_ate, $disposit, $observac,$ori_prod, $infoAdic, $cenq);

        $response = 'ok';
        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();     
        $response = $e->getMessage();
        return $response;
    }
}

function update_ipi($ins_ipi, $idcenario, $cod_prod, $rulesClass, $ori_prod){
    try{
        $ipi = $ins_ipi;
        $cst       = $ipi->cst;
        $bc_compos = (property_exists($ipi, 'bc_composicao')) ? $ipi->bc_composicao : '';
        $aliquota  = (property_exists($ipi, 'aliquota'))      ? $ipi->aliquota : 0;
        $p_red_bc  = (property_exists($ipi, 'p_red_bc'))      ? $ipi->p_red_bc : '';
        $vigen_de  = (property_exists($ipi, 'vigencia_de'))   ? $ipi->vigencia_de : '';
        $vigen_ate = (property_exists($ipi, 'vigencia_ate'))  ? $ipi->vigencia_ate : '';
        $disposit  = (property_exists($ipi, 'dispositivo'))   ? $ipi->dispositivo : '';
        $observac  = (property_exists($ipi, 'observacao'))    ? $ipi->observacao : '';
        $cenq      = (property_exists($ipi, 'cenq'))          ? $ipi->cenq : '';
        $infoAdic  = (property_exists($ipi, 'inf_adicionais'))    ? $ipi->inf_adicionais : '';
        
        
        $rulesClass->update_ipi('SYS_IPI', $idcenario, $cod_prod, $cst, $bc_compos, $aliquota, $p_red_bc, $vigen_de, $vigen_ate, $disposit, $observac,$infoAdic, $cenq, $ori_prod);

        $response = 'ok';
        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();     
        $response = $e->getMessage();
        return $response;
    }
}

function insere_icmsst($ins_icms, $idcenario, $cod_prod, $rulesClass, $ori_prod){
    try{
        $icms      = $ins_icms;
        $bc_compos = (property_exists($icms, 'bc_composicao')) ? $icms->bc_composicao : '';
        $aliquota  = (property_exists($icms, 'aliquota_st'))      ? $icms->aliquota_st : 0;
        $p_red_bc  = (property_exists($icms, 'p_red_bc'))      ? $icms->p_red_bc : '';
        $vigen_de  = (property_exists($icms, 'vigencia_de'))   ? $icms->vigencia_de : '';
        $vigen_ate = (property_exists($icms, 'vigencia_ate'))  ? $icms->vigencia_ate : '';
        $disposit  = (property_exists($icms, 'dispositivo'))   ? $icms->dispositivo : '';
        $observac  = (property_exists($icms, 'observacao'))    ? $icms->observacao : '';
        $infoAdic  = '';

        $rulesClass->insere_imp_systax('SYS_ICMSST', $idcenario, $cod_prod, '', $bc_compos, $aliquota, $p_red_bc, $vigen_de, $vigen_ate, $disposit, $observac, $ori_prod, $infoAdic);

        $response = 'ok';
        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();
        $response = $e->getMessage();
        return $response;
    }
}

function update_icmsst($ins_icms, $idcenario, $cod_prod, $rulesClass, $ori_prod){
    try{
        $icms      = $ins_icms;
        $bc_compos = (property_exists($icms, 'bc_composicao')) ? $icms->bc_composicao : '';
        $aliquota  = (property_exists($icms, 'aliquota_st'))      ? $icms->aliquota_st : 0;
        $p_red_bc  = (property_exists($icms, 'p_red_bc'))      ? $icms->p_red_bc : '';
        $vigen_de  = (property_exists($icms, 'vigencia_de'))   ? $icms->vigencia_de : '';
        $vigen_ate = (property_exists($icms, 'vigencia_ate'))  ? $icms->vigencia_ate : '';
        $disposit  = (property_exists($icms, 'dispositivo'))   ? $icms->dispositivo : '';
        $observac  = (property_exists($icms, 'observacao'))    ? $icms->observacao : '';

        $rulesClass->update_icmsst('SYS_ICMSST', $idcenario,  $cod_prod, '', $bc_compos, $aliquota, $p_red_bc, $vigen_de, $vigen_ate, $disposit, $observac, '', $ori_prod);
        $response = 'ok';
        return $response;
    }catch(SoapFault $e){
        echo $e->getMessage();
        $response = $e->getMessage();
        return $response;
    }
}